// ************************************************************************************************
/*
GoodFields . modules de gestion de bar-graphes sur LCD standards
21/11/2013
*/
// pr-dclaration
char* ger_bargraph (int valeur, float e_mini, float e_maxi, float s_mini, float s_maxi, float b_mini, float b_maxi, int nbcar, int nbchiffres, char unite, float &sortie);

// ************************************************************************************************
//#define creercaracterestype  1 //
//#define creercaracteresdemo  1 // si on veut un test au dmarrage
// ************************************************************************************************
// cration de caractres spcifiques
/* http://arduino.cc/fr/Main/LcdcreateChar
	
	creercaracterestype : 
        0 ou non dfini = 5 barres simples
		1 = 5 pavs grossissants
		2 = 3 barres simples

	creercaracteresdemo : 
        non dfini = rien
		affichage des caractres au dmarrage sur le LCD

Autres standards :
0 barre = espace = cacactre 32
5 barres soulignes = caractre 255
*/
void ger_creercaracteres() {

int i;
float x;
// barres simples
#ifndef creercaracterestype
#define creercaracterestype 0
#endif
#if creercaracterestype == 0
byte carrepro1[8] = { B00000, B00000, B00000, B00000, B00000, B00000, B00000};	// 0 barre
byte carrepro2[8] = { B10000, B10000, B10000, B10000, B10000, B10000, B10000};	// 1 barre
byte carrepro3[8] = { B11000, B11000, B11000, B11000, B11000, B11000, B11000};	// 2 barres
byte carrepro4[8] = { B11100, B11100, B11100, B11100, B11100, B11100, B11100};	// 3 barres
byte carrepro5[8] = { B11110, B11110, B11110, B11110, B11110, B11110, B11110};	// 4 barres
byte carrepro6[8] = { B11111, B11111, B11111, B11111, B11111, B11111, B11111};	// 5 barres
#define nbre_sousechelons 5
#endif

// pave grossissant et soulign
#if creercaracterestype == 1
byte carrepro1[9] = { B00000, B00000, B00000, B00000, B00000, B00000, B00000, B10101};	// 0 barre
byte carrepro2[9] = { B00000, B00000, B00000, B00000, B10000, B10000, B10000, B10101};	// 1 barre
byte carrepro3[9] = { B00000, B00000, B00000, B11000, B11000, B11000, B11000, B10101};	// 2 barres
byte carrepro4[9] = { B00000, B00000, B11100, B11100, B11100, B11100, B11100, B10101};	// 3 barres
byte carrepro5[9] = { B00000, B11110, B11110, B11110, B11110, B11110, B11110, B10101};	// 4 barres
byte carrepro6[9] = { B11111, B11111, B11111, B11111, B11111, B11111, B11111, B10101};	// 5 barres
#define nbre_sousechelons 5
#endif

#if creercaracterestype == 2
// nos nouveaux caractres, 4 niveaux
byte carrepro1[9] = { B00000, B00000, B00000, B00000, B00000, B00000, B00000, B10101};	// 0 barre
byte carrepro2[9] = { B10000, B10000, B10000, B10000, B10000, B10000, B10000, B10101};	// 1 barre
byte carrepro3[9] = { B10100, B10100, B10100, B10100, B10100, B10100, B10100, B10101};	// 2 barres cartes
byte carrepro4[9] = { B10101, B10101, B10101, B10101, B10101, B10101, B10101, B10101};	// 3 barres cartes
byte carrepro5[1] = { 0};
byte carrepro6[1] = { 0};
#define nbre_sousechelons 3
#endif

// autres caracrtres
byte carrepro7[8] = { B01000, B10100, B01000, B00011, B00100, B00100, B00011 };	// C
byte carrepro8[8] = { B11101, B10111, B10110, B10000, B10111, B10001, B11111 };	// logo GR

// NB: ne pas programmer le caractre 0, car c'est la fin de chaines de caractres
// apprend les caractres  l'cran LCD
  lcd.createChar(1, carrepro1);
  lcd.createChar(2, carrepro2); 
  lcd.createChar(3, carrepro3); 
  lcd.createChar(4, carrepro4); 
  lcd.createChar(5, carrepro5);
  lcd.createChar(6, carrepro6); 
  lcd.createChar(7, carrepro7); 
  lcd.createChar(8, carrepro8);

#ifdef creercaracteresdemo
	Serial && "creercaracteres:demo" && endli;
// TEST CARACTERES
  for (i=1;i<9;i++) {
    lcd.setCursor(i-1, 0);  lcd && char(i); // lcd.write((uint8_t) char(i)); //affiche le caractre
    lcd.setCursor(i-1, 1);  lcd && i;
  }
// demo bargraph
	for (i=0;i<30;i++) {
      lcd.setCursor(10, 0);  lcd && ger_bargraph (i, 0., 30., 0., 30., 0., 30., 6, 3, ' ', x);
      lcd.setCursor(10, 1);  lcd && ger_bargraph (29-i, 0., 30., 0., 30., 0., 30., 6, 3, ' ', x);
	  delay(100);
    }
#endif
}
//**********************************************************
// conversion d'une entre (entire) en sortie (flottante mise  l'chelle)
// et cration d'une chaine de caractres bargraph
/*
valeur = entier (typiquement entre analogique de 0  1023)
e_mini = valeur minimale
e_maxi = valeur maximale
s_mini = sortie correspondante  valeur minimale
s_maxi = sortie correspondante  valeur maximale
b_mini = valeur flottante de sortie correspondante au mini du bargraph
b_maxi = valeur flottante de sortie correspondante au maxi du bargraph
nbcar = nombre de caractres du bargraph
nbchiffres = nombre de chiffres de la valeur (non comprise multiplicateur+unit) 
  si NEGATIF, la valeur est mise APRES la barre, en plus !
unite = 1 caractre pour l'unit. si " " = pas de valeur
sortie : sortie (en flottant)
*/
char* ger_bargraph (int valeur, float e_mini, float e_maxi, float s_mini, float s_maxi, float b_mini, float b_maxi, int nbcar, int nbchiffres, char unite, float &sortie) {

static char local[21];
char buf[15];
int i,j,nbre_echelons;
    
    sortie = ((valeur - e_mini) * (s_maxi - s_mini) / (e_maxi - e_mini) ) + s_mini;
//
    nbre_echelons = (float) nbcar * nbre_sousechelons * (sortie - b_mini) / (b_maxi - b_mini);
    nbre_echelons = constrain(nbre_echelons, 0, nbcar * nbre_sousechelons);
// nettoyage du buffer
    memset (local,char(1),nbcar); // raz pavs blancs (30448)
//	for (j=0;j<nbcar;j++) {local[j] = char(1); } // raz pavs blancs (30458)
	

// affichage d'un bargraph compos de nbcar caractres 'bloc' maximum
    i = nbre_echelons/nbre_sousechelons;
    if (i>0) memset (local,char(nbre_sousechelons+1),i); // mise en place des blocs pleins

//    Serial << " nbre_echelons=" << nbre_echelons << " ";  // debug/test (sans LCD !!!)
//    for (j=0;j<i;j++) Serial << "#";  // bargraphe - debug/test (sans LCD !!!) 

// mise en place d'un caractre programm parmi  
//    if (i>0 && i<nbcar) local[i] = char(nbre_echelons%nbre_sousechelons+1);
    if (i<nbcar) local[i] = char(nbre_echelons%nbre_sousechelons+1);

// affichage des butes hors graphe
    if (sortie > b_maxi) local[nbcar-1]='>';
    if (sortie < b_mini) local[0]='<';
   
// affichage de la valeur numerique
   i=0;
   if (unite != ' ') {
		formatt (sortie, unite, abs(nbchiffres), buf);
		i=strlen(buf); 
// conomie des blancs en fin de chaine
		if (buf[i-1] == ' ' ) i--; 
		if (buf[i-1] == ' ' ) i--; 
// en surimpression
        if (nbchiffres > 0) {
			for (j=0;j<i;j++) {
				if ( sortie > (b_mini+b_maxi)/2 ) {
					local[j] = buf[j];
				} else {
					local[nbcar-i+j] = buf [j];
				}
			}
			i=0;		// pour raz correcte !
// en plus , derrire
		} else {
			for (j=0;j<i;j++) {local[nbcar+j] = buf[j]; }
		}
    }
// fin chaine
    local[nbcar+i]='\0';
// debug/test    
//for (j=0;j<nbcar+i+1;j++) Serial && j && "=" && _DEC(local[j]) && " ";
//Serial && endli; 

return local;
}
// ************************************************************************************************
